/****************************************************************/
/* squeue.h - Static Queue Header				*/
/****************************************************************/
/*
 *  (c)2006 Todd Shadburn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/****************************************************************/


#ifndef _SQUEUE_H_
#define _SQUEUE_H_

#include <cutil/cutil_portable.h>

#define ESUCCESS	0

typedef struct _SQueue		SQueue;
struct _SQueue {
	unsigned long	queuesize;
	unsigned long	itemsize;
	unsigned long	writepos;
	unsigned long	readpos;
	unsigned long	items;
	char		*queuedata;
};


CUTIL_API int squeue_new (SQueue **queuep,
		unsigned long itemsize,
		unsigned long maxitems);
CUTIL_API int squeue_free (SQueue **queuep);
CUTIL_API int squeue_item_enqueue (SQueue *queue, void *data);
CUTIL_API int squeue_item_dequeue (SQueue *queue, void *data);
CUTIL_API int squeue_item_peek (SQueue *queue, void *data);
CUTIL_API int squeue_item_count (SQueue *list, int *countp);

#endif

